<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: sockets_kernel_1.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_db4292552f143a18c3a7d21c79340952.html">sockets</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">sockets_kernel_1.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2003  Davis E. King (davis@dlib.net), Miguel Grinberg</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_SOCKETS_KERNEl_1_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_SOCKETS_KERNEl_1_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifdef DLIB_ISO_CPP_ONLY</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#error &quot;DLIB_ISO_CPP_ONLY is defined so you can&#39;t use this OS dependent code.  Turn DLIB_ISO_CPP_ONLY off if you want to use it.&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;sockets_kernel_abstract.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;../threads.h&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;../smart_pointers.h&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;../uintn.h&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;{</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="comment">// forward declarations</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">class </span>socket_factory;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">class </span>listener;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">class </span>SOCKET_container;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="comment">// lookup functions</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">int</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    get_local_hostname (</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        std::string&amp; hostname</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    );</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment">// -----------------</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">int</span> </div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    hostname_to_ip (</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">const</span> std::string&amp; hostname,</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        std::string&amp; ip,</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keywordtype">int</span> n = 0</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    );</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment">// -----------------</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">int</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    ip_to_hostname (</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keyword">const</span> std::string&amp; ip,</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        std::string&amp; hostname</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    );</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="comment">// connection object</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classdlib_1_1connection.html">   61</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1connection.html">connection</a></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    {</div><div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classdlib_1_1connection.html#a6e027ffa043575312851d123228ae8eb">   87</a></span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classdlib_1_1listener.html">listener</a>;                <span class="comment">// make listener a friend of connection</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="comment">// make create_connection a friend of connection</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">int</span> create_connection ( </div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            <a class="code" href="classdlib_1_1connection.html">connection</a>*&amp; new_connection,</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> foreign_port, </div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            <span class="keyword">const</span> std::string&amp; foreign_ip, </div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> local_port,</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keyword">const</span> std::string&amp; local_ip </div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        );</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        ~<a class="code" href="classdlib_1_1connection.html">connection</a> (</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        );</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordtype">void</span>* user_data;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keywordtype">long</span> write (</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">char</span>* buf, </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            <span class="keywordtype">long</span> num</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        );</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keywordtype">long</span> read (</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="keywordtype">char</span>* buf, </div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <span class="keywordtype">long</span> num</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        );</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160; </div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="keywordtype">long</span> read (</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            <span class="keywordtype">char</span>* buf, </div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            <span class="keywordtype">long</span> num,</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdlib_1_1timeout.html">timeout</a></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        );</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> get_local_port (</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        )<span class="keyword"> const </span>{  <span class="keywordflow">return</span> connection_local_port; }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> get_foreign_port ( </div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> connection_foreign_port; }</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keyword">const</span> std::string&amp; get_local_ip (</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> connection_local_ip; }</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        <span class="keyword">const</span> std::string&amp; get_foreign_ip (</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> connection_foreign_ip; }</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="keywordtype">int</span> shutdown_outgoing (</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        );</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordtype">int</span> shutdown (</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        );</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="comment">// I would use SOCKET here but I don&#39;t want to include the windows</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="comment">// header files since they bring in a bunch of unpleasantness.  So</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="comment">// I&#39;m doing this instead which should ultimately be the same type</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="comment">// as the SOCKET win the windows API.</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keyword">typedef</span> unsigned_type&lt;void*&gt;::type socket_descriptor_type;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160; </div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordtype">int</span> disable_nagle(</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        );</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        socket_descriptor_type get_socket_descriptor (</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160; </div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160; </div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keywordtype">bool</span> readable (</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> timeout </div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="classdlib_1_1connection.html#ac88ea9e190502954ef118230966d15f9">  164</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classdlib_1_1connection.html#ac88ea9e190502954ef118230966d15f9">sd_called</a> (</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        )const</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;            sd_mutex.lock();</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            <span class="keywordtype">bool</span> temp = sd;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;            sd_mutex.unlock();</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            <span class="keywordflow">return</span> temp;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        }</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160; </div><div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="classdlib_1_1connection.html#a46d86d6587a2f22f36007513aebc9738">  178</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classdlib_1_1connection.html#a46d86d6587a2f22f36007513aebc9738">sdo_called</a> (</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        )const</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        {</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;            sd_mutex.lock();</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            <span class="keywordtype">bool</span> temp = <span class="keyword">false</span>;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            <span class="keywordflow">if</span> (sdo || sd)</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                temp = <span class="keyword">true</span>;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            sd_mutex.unlock();</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            <span class="keywordflow">return</span> temp;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        }</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160; </div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160; </div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        <span class="comment">// data members</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        SOCKET_container&amp; connection_socket;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> connection_foreign_port;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keyword">const</span> std::string connection_foreign_ip; </div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> connection_local_port;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keyword">const</span> std::string connection_local_ip;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keywordtype">bool</span> sd;  <span class="comment">// called shutdown</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keywordtype">bool</span> sdo; <span class="comment">// called shutdown_outgoing</span></div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keywordtype">int</span> sdr; <span class="comment">// return value for shutdown </span></div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <a class="code" href="classdlib_1_1mutex.html">mutex</a> sd_mutex; <span class="comment">// a lock for the three above vars</span></div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160; </div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        <a class="code" href="classdlib_1_1connection.html#aff76f02117470036bd38034b6812adec">connection</a>(</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            SOCKET_container sock,</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> foreign_port, </div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            <span class="keyword">const</span> std::string&amp; foreign_ip, </div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> local_port,</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            <span class="keyword">const</span> std::string&amp; local_ip</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        ); </div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        <span class="comment">// restricted functions</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        <a class="code" href="classdlib_1_1connection.html#aff76f02117470036bd38034b6812adec">connection</a>(<a class="code" href="classdlib_1_1connection.html">connection</a>&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        <a class="code" href="classdlib_1_1connection.html">connection</a>&amp; operator=(<a class="code" href="classdlib_1_1connection.html">connection</a>&amp;);    <span class="comment">// assignment operator</span></div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    }; </div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160; </div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    <span class="comment">// listener object</span></div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160; </div><div class="line"><a name="l00236"></a><span class="lineno"><a class="line" href="classdlib_1_1listener.html">  236</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1listener.html">listener</a></div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    {</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        <span class="comment">// make the create_listener a friend of listener</span></div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">int</span> <a class="code" href="classdlib_1_1listener.html#a09a3b6d05024affbb23d2db60133c8d7">create_listener</a> (</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            <a class="code" href="classdlib_1_1listener.html">listener</a>*&amp; new_listener,</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> port,</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            <span class="keyword">const</span> std::string&amp; ip </div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        );</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160; </div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160; </div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        ~<a class="code" href="classdlib_1_1listener.html">listener</a> (</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        );</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160; </div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        <span class="keywordtype">int</span> accept (</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            <a class="code" href="classdlib_1_1connection.html">connection</a>*&amp; new_connection,</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdlib_1_1timeout.html">timeout</a> = 0</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        );</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160; </div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="keywordtype">int</span> accept (</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            <a class="code" href="classdlib_1_1scoped__ptr.html">scoped_ptr&lt;connection&gt;</a>&amp; new_connection,</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdlib_1_1timeout.html">timeout</a> = 0</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        );</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160; </div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> get_listening_port (</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        ) { <span class="keywordflow">return</span> listening_port; }</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160; </div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keyword">const</span> std::string&amp; get_listening_ip (</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        ) { <span class="keywordflow">return</span> listening_ip; }</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160; </div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160; </div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="comment">// data members</span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        SOCKET_container&amp; listening_socket;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> listening_port;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        <span class="keyword">const</span> std::string listening_ip;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">bool</span> inaddr_any;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160; </div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        <a class="code" href="classdlib_1_1listener.html#af23e31e10d954a74df6fd7dc3956a4aa">listener</a>(</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            SOCKET_container sock,</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> port,</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            <span class="keyword">const</span> std::string&amp; ip</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        );</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        <span class="comment">// restricted functions</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        <a class="code" href="classdlib_1_1listener.html#af23e31e10d954a74df6fd7dc3956a4aa">listener</a>(<a class="code" href="classdlib_1_1listener.html">listener</a>&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        <a class="code" href="classdlib_1_1listener.html">listener</a>&amp; operator=(<a class="code" href="classdlib_1_1listener.html">listener</a>&amp;);    <span class="comment">// assignment operator</span></div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    };</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160; </div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160; </div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="namespacedlib.html#a3605644e23d9a620160f4eefec0ea3aa">create_listener</a> (</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        <a class="code" href="classdlib_1_1listener.html">listener</a>*&amp; new_listener,</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> port,</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        <span class="keyword">const</span> std::string&amp; ip = <span class="stringliteral">&quot;&quot;</span></div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    );</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160; </div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <span class="keywordtype">int</span> create_connection ( </div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        <a class="code" href="classdlib_1_1connection.html">connection</a>*&amp; new_connection,</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> foreign_port, </div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keyword">const</span> std::string&amp; foreign_ip, </div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> local_port = 0,</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        <span class="keyword">const</span> std::string&amp; local_ip = <span class="stringliteral">&quot;&quot;</span></div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    );</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="namespacedlib.html#a3605644e23d9a620160f4eefec0ea3aa">create_listener</a> (</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        <a class="code" href="classdlib_1_1scoped__ptr.html">scoped_ptr&lt;listener&gt;</a>&amp; new_listener,</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> port,</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <span class="keyword">const</span> std::string&amp; ip = <span class="stringliteral">&quot;&quot;</span></div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    );</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160; </div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    <span class="keywordtype">int</span> create_connection ( </div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        <a class="code" href="classdlib_1_1scoped__ptr.html">scoped_ptr&lt;connection&gt;</a>&amp; new_connection,</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> foreign_port, </div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        <span class="keyword">const</span> std::string&amp; foreign_ip, </div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> local_port = 0,</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;        <span class="keyword">const</span> std::string&amp; local_ip = <span class="stringliteral">&quot;&quot;</span></div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;    );</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160; </div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160; </div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160; </div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;}</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160; </div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;<span class="preprocessor">#ifdef NO_MAKEFILE</span></div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;<span class="preprocessor">#include &quot;sockets_kernel_1.cpp&quot;</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160; </div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;<span class="preprocessor">#endif // DLIB_SOCKETS_KERNEl_1_</span></div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1connection_html_aff76f02117470036bd38034b6812adec"><div class="ttname"><a href="classdlib_1_1connection.html#aff76f02117470036bd38034b6812adec">dlib::connection::connection</a></div><div class="ttdeci">connection()</div></div>
<div class="ttc" id="aclassdlib_1_1mutex_html"><div class="ttname"><a href="classdlib_1_1mutex.html">dlib::mutex</a></div><div class="ttdef"><b>Definition:</b> threads_kernel_1.h:39</div></div>
<div class="ttc" id="aclassdlib_1_1listener_html"><div class="ttname"><a href="classdlib_1_1listener.html">dlib::listener</a></div><div class="ttdef"><b>Definition:</b> sockets_kernel_1.h:236</div></div>
<div class="ttc" id="aclassdlib_1_1connection_html_ac88ea9e190502954ef118230966d15f9"><div class="ttname"><a href="classdlib_1_1connection.html#ac88ea9e190502954ef118230966d15f9">dlib::connection::sd_called</a></div><div class="ttdeci">bool sd_called() const</div><div class="ttdef"><b>Definition:</b> sockets_kernel_1.h:164</div></div>
<div class="ttc" id="aclassdlib_1_1connection_html_a46d86d6587a2f22f36007513aebc9738"><div class="ttname"><a href="classdlib_1_1connection.html#a46d86d6587a2f22f36007513aebc9738">dlib::connection::sdo_called</a></div><div class="ttdeci">bool sdo_called() const</div><div class="ttdef"><b>Definition:</b> sockets_kernel_1.h:178</div></div>
<div class="ttc" id="aclassdlib_1_1connection_html"><div class="ttname"><a href="classdlib_1_1connection.html">dlib::connection</a></div><div class="ttdef"><b>Definition:</b> sockets_kernel_1.h:61</div></div>
<div class="ttc" id="aclassdlib_1_1timeout_html"><div class="ttname"><a href="classdlib_1_1timeout.html">dlib::timeout</a></div><div class="ttdef"><b>Definition:</b> timeout/timeout.h:26</div></div>
<div class="ttc" id="aclassdlib_1_1listener_html_a09a3b6d05024affbb23d2db60133c8d7"><div class="ttname"><a href="classdlib_1_1listener.html#a09a3b6d05024affbb23d2db60133c8d7">dlib::listener::create_listener</a></div><div class="ttdeci">friend int create_listener(listener *&amp;new_listener, unsigned short port, const std::string &amp;ip)</div><div class="ttdef"><b>Definition:</b> sockets_kernel_2.cpp:806</div></div>
<div class="ttc" id="anamespacedlib_html_a3605644e23d9a620160f4eefec0ea3aa"><div class="ttname"><a href="namespacedlib.html#a3605644e23d9a620160f4eefec0ea3aa">dlib::create_listener</a></div><div class="ttdeci">int create_listener(listener *&amp;new_listener, unsigned short port, const std::string &amp;ip=&quot;&quot;)</div><div class="ttdef"><b>Definition:</b> sockets_kernel_2.cpp:806</div></div>
<div class="ttc" id="aclassdlib_1_1scoped__ptr_html"><div class="ttname"><a href="classdlib_1_1scoped__ptr.html">dlib::scoped_ptr</a></div><div class="ttdef"><b>Definition:</b> scoped_ptr.h:40</div></div>
<div class="ttc" id="aclassdlib_1_1listener_html_af23e31e10d954a74df6fd7dc3956a4aa"><div class="ttname"><a href="classdlib_1_1listener.html#af23e31e10d954a74df6fd7dc3956a4aa">dlib::listener::listener</a></div><div class="ttdeci">listener()</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
